// testFeatureExtract.cpp
//

#include "stdafx.h"
#include <vector>
using namespace std;
#include "cv.h"
#include "highgui.h"
#include "..\..\lib\FeatureExtract.h"

#pragma warning (disable: 4018 4244)

#ifndef MAX_PATH
	#define MAX_PATH 260
#endif


char g_sImagePath[MAX_PATH];
char g_sFeaturePath[MAX_PATH];


// Encode a single palmprint
void DoSingle(char* sTitle)
{
	strcpy(g_sImagePath, "E:\\mypaper\\Published\\PAMI09_Palm\\code\\SDK\\v1.1-for Alessandra\\data\\image\\");
	strcpy(g_sFeaturePath, "E:\\mypaper\\Published\\PAMI09_Palm\\code\\SDK\\v1.1-for Alessandra\\data\\feature\\");

	CFeatureExtract extract;
	strcpy(extract.m_sImagePath, g_sImagePath);
	strcpy(extract.m_sFeaturePath, g_sFeaturePath);
	strcpy(extract.m_sTitle, sTitle);// Fingerprint image is assumed to be sTitle.bmp

	if(!extract.LoadData())
	{
		printf("Load image fail!\n");
		return;
	}

	extract.ExtractFeature();

	extract.SaveFeature();// Save features in m_sFeaturePath

#ifdef _SHOW_WINDOW_
	extract.ProcessKeyboardCommand();// Press 'm' to show minutiae; 'd' for direction field; 'r' for ridge image; 'g' for gray image; 'Esc' to exit;
#endif
}



// Encode palmprints in PV-TEST
void DoBat_PV_TEST()
{
	strcpy(g_sImagePath, "F:\\data\\PVC\\PV-TEST2\\image\\");
	strcpy(g_sFeaturePath, "F:\\data\\PVC\\PV-TEST2\\feature\\v0.1\\");
	for(int i = 1; i <= 10; i++)
	{
		for(int j = 1; j <= 8; j++)
		{
			char sTitle[MAX_PATH];
			sprintf(sTitle, "T%02d_F%d", i, j);
			CFeatureExtract extract;
			strcpy(extract.m_sImagePath, g_sImagePath);
			strcpy(extract.m_sFeaturePath, g_sFeaturePath);
			strcpy(extract.m_sTitle, sTitle);

			if(!extract.LoadData())
			{
				printf("Load image fail!\n");
				return;
			}

			extract.ExtractFeature();

			extract.SaveFeature();// save features in m_sFeaturePath
		}
	}
}



int _tmain(int argc, _TCHAR* argv[])
{
	CFeatureExtract::Initialize();

	//DoSingle("a");
	//DoSingle("b");
	DoBat_PV_TEST();

	CFeatureExtract::ClearMemory();
	return 0;
}

