#pragma once

//#define _SECURE_SCL 0
#define	_SHOW_WINDOW_
//#define	_TRACE_FUNCTION_


extern bool g_bUseCrease;

enum GuiMode {mode_gray=0, mode_enhance, mode_dir, mode_period, mode_ridge, mode_minu, mode_blockQuality, mode_filter};

class CWaveGroup;
class CPreProcess;
class CPostProcess;

class CFeatureExtract
{
public:
	// These three variables should be inputted by the user
	char			m_sImagePath[1000];
	char			m_sFeaturePath[1000];
	char			m_sTitle[1000];

	CWaveGroup*		m_pWaveGroup;
	CPreProcess*	m_pPreProcess;
	CPostProcess*	m_pPostProcess;

	int				m_iHeight;
	int				m_iWidth;

#ifdef _SHOW_WINDOW_
	GuiMode			m_mode;
	IplImage*		m_pShowImage;
	char			m_sWindowName[MAX_PATH];

	void			ProcessMouseCommand(int event, int x, int y, int flags);
	void			ProcessKeyboardCommand();
	char			ShowImage();
	void			ShowImageNoWait();
#endif

public:
	CFeatureExtract();
	~CFeatureExtract();
	static void		ClearMemory();
	static bool		Initialize();
	bool			LoadData();
	bool			LoadGrayImage(char* fname);
	bool			LoadDirImage(char* ftitle);
	bool			LoadDirText(char* ftitle);
	bool			LoadFreqImage(char* ftitle);
	bool			LoadThinImage(char* ftitle);
	bool			LoadCreaseImage(char* ftitle);
	void			ExtractFeature();
	void			ComputeBlockFeature();
	void			SaveFeature();

private:
};
